<template>
  <div class="column is-half">
    <h1 class="title">Welcome to Uncover!</h1>
    <hr>
    <p>Let's setup your account. First, choose a username, and add some details about yourself.</p>
    <br>
    <form class="form">
      <div class="field is-horizontal">
        <div class="field-body">
          <b-field label="First Name">
            <b-input v-model="user.firstname"></b-input>
          </b-field>
          <b-field label="Last Name">
            <b-input v-model="user.lastname"></b-input>
          </b-field>
        </div>
      </div>
      <div class="field is-horizontal">
        <div class="field-body">
          <b-field label="Locality">
            <b-input
            icon="map-pin"
            v-model="user.locality"></b-input>
          </b-field>
          <b-field label="Date of Birth">
          <b-datepicker
              placeholder="Click to select..."
              icon="calendar-alt"
              v-model="user.dob">
            </b-datepicker>
          </b-field>
        </div>
      </div>
      <br>
      <div class="control is-pulled-right">
        <button
          class="button is-primary is-outlined"
          :class="{'is-loading': isLoading}"
          @click="saveAccountDetails">Next</button>
      </div>
    </form>
  </div>
</template>

<script>
import gql from 'graphql-tag'
import UPDATEUSERPROFILE_MUTATION from '@/graphql/User/UpdateUserProfile.gql'
export default {
  data () {
    return {
      user: {},
      isLoading: false
    }
  },
  created () {
    this.$apollo.query({
      query: gql`query getUserOnboardStatus ($userId: ID!) {
        User (id: $userId) {
          onboardStatus
        }
      }`,
      variables: {
        userId: localStorage.getItem('apollo-user')
      }
    }).then(({ data: { User: { onboardStatus } } }) => {
      if (onboardStatus === 1) this.$router.push({ name: 'onboard-profile' })
      else if (onboardStatus === 2) this.$router.push({ name: 'feed' })
    })
  },
  methods: {
    saveAccountDetails () {
      this.isLoading = true
      this.user.id = localStorage.getItem('apollo-user')
      this.user.onboardStatus = 1
      this.$apollo.mutate({
        mutation: UPDATEUSERPROFILE_MUTATION,
        variables: {
          ...this.user
        }
      }).then(({ data: { updateUser } }) => {
        this.$store.dispatch('fetchUserProfile', updateUser.id)
        this.$router.push({ name: 'onboard-profile' })
      })
    }
  }
}
</script>
